package se.softstuff.nb.translate.omegat;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import org.openide.DialogDisplayer;
import org.openide.NotifyDescriptor;
import org.openide.util.NbBundle;
import org.openide.util.NbPreferences;

/**
 *
 * @author stefan
 */
public class ExportPanel extends javax.swing.JPanel {
    private static final String LAST_DICTIONARY= "last-dictionary";
    private static final String LAST_DESTINATION= "last-destination";
    
            
    /**
     * Creates new form ExportPanel
     */
    public ExportPanel() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        dictionaryLabel = new javax.swing.JLabel();
        destinationLabel = new javax.swing.JLabel();
        dictionaryTextField = new javax.swing.JTextField();
        dictionaryButton = new javax.swing.JButton();
        destinationTextField = new javax.swing.JTextField();
        destinationButton = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setName(org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.name")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(dictionaryLabel, org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.dictionaryLabel.text")); // NOI18N
        dictionaryLabel.setName("dictionaryLabel"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(destinationLabel, org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.destinationLabel.text")); // NOI18N
        destinationLabel.setName(org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.destinationLabel.name")); // NOI18N

        dictionaryTextField.setName(org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.dictionaryTextField.name")); // NOI18N

        dictionaryButton.setLabel(org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.dictionaryButton.label")); // NOI18N
        dictionaryButton.setName("dictionaryButton"); // NOI18N
        dictionaryButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dictionaryButtonActionPerformed(evt);
            }
        });

        destinationTextField.setName("destinationTextField"); // NOI18N

        destinationButton.setLabel(org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.destinationButton.label")); // NOI18N
        destinationButton.setName("destinationButton"); // NOI18N
        destinationButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                destinationButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(jButton3, org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.jButton3.text")); // NOI18N
        jButton3.setName(org.openide.util.NbBundle.getMessage(ExportPanel.class, "ExportPanel.jButton3.name")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(dictionaryLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(destinationLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(dictionaryTextField)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(dictionaryButton))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(destinationTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 217, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(destinationButton))))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jButton3)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(dictionaryLabel)
                    .addComponent(dictionaryTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(dictionaryButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(destinationLabel)
                    .addComponent(destinationTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(destinationButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 39, Short.MAX_VALUE)
                .addComponent(jButton3)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void dictionaryButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dictionaryButtonActionPerformed
        
        String lastLocation = NbPreferences.forModule(getClass()).get(LAST_DICTIONARY, ".");
        JFileChooser projectChooser = new JFileChooser();
        projectChooser.setCurrentDirectory(new File(lastLocation));
        projectChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        projectChooser.setMultiSelectionEnabled(false);
        projectChooser.setDialogTitle(NbBundle.getMessage(getClass(), "ExportPanel.dictionaryDialog.title"));
        projectChooser.showOpenDialog(this);
        final File dictionaryFolder = projectChooser.getSelectedFile();
        if (dictionaryFolder == null) {
            return;
        }
        String currentDir = dictionaryFolder.getAbsolutePath();
        dictionaryTextField.setText(currentDir);
        NbPreferences.forModule(getClass()).put(LAST_DICTIONARY, currentDir);
    }//GEN-LAST:event_dictionaryButtonActionPerformed

    private void destinationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_destinationButtonActionPerformed
        
        String lastLocation = NbPreferences.forModule(getClass()).get(LAST_DESTINATION, ".");
        JFileChooser projectChooser = new JFileChooser();
        projectChooser.setCurrentDirectory(new File(lastLocation));
        projectChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        projectChooser.setFileFilter(new EmptyFolderFilter());
        projectChooser.setMultiSelectionEnabled(false);
        projectChooser.setDialogTitle(NbBundle.getMessage(getClass(), "ExportPanel.dictionaryDialog.title"));
        projectChooser.showOpenDialog(this);
        final File dictionaryFolder = projectChooser.getSelectedFile();
        if (dictionaryFolder == null) {
            return;
        }
        
        if(!dictionaryFolder.isDirectory() || dictionaryFolder.list().length != 0){
            
            NotifyDescriptor d =
            new NotifyDescriptor.Message(
                    NbBundle.getMessage(getClass(), "ExportPanel.notEmptyFolder.message", dictionaryFolder.getName()),
                    NotifyDescriptor.INFORMATION_MESSAGE);
                DialogDisplayer.getDefault().notify(d);

            return;
        }
        
        String currentDir = dictionaryFolder.getAbsolutePath();
        dictionaryTextField.setText(currentDir);
        NbPreferences.forModule(getClass()).put(LAST_DESTINATION, currentDir);
        
    }//GEN-LAST:event_destinationButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton destinationButton;
    private javax.swing.JLabel destinationLabel;
    private javax.swing.JTextField destinationTextField;
    private javax.swing.JButton dictionaryButton;
    private javax.swing.JLabel dictionaryLabel;
    private javax.swing.JTextField dictionaryTextField;
    private javax.swing.JButton jButton3;
    // End of variables declaration//GEN-END:variables

    private static class EmptyFolderFilter extends FileFilter {

        @Override
        public boolean accept(File fileToTest) {            
            return fileToTest.isDirectory() && fileToTest.list().length == 0;
        }

        @Override
        public String getDescription() {
            return NbBundle.getMessage(ExportPanel.class, "ExportPanel.EmptyFolderFilter.description");
        }
    }
}
